<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
<TITLE>Cours/TD - 11</TITLE>
<link REL="StyleSheet" TYPE="text/css" HREF="Costyle.css">
</HEAD>
<BODY BACKGROUND="../icons/flock1.gif">

<CENTER><H1>Cours/TD - (11)</H1>
</CENTER>
<P>

<TABLE width=100%>
 <TR><TD align=left><A HREF="comres10.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres12.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>
<FONT COLOR=#0000FF FACE="Helvetica,Arial" point-size=14pt>
<H3><FONT COLOR=#f00000>04.01.00</FONT></H3>
<p>

<H2>Cours</H2>
<H3>Attributs et analyse sémantique</H3>
<p>

Une grammaire qui définit la syntaxe d'un langage ne contient presqu'aucune information concrète sur sa sémantique, pourtant cette question est tout simplement primordiale. La syntaxe sans sémantique n'a aucune utilité. Le parseur doit construire un résultat sous forme arborescente, linéaire, fonctionnelle, etc. - parfois tout cela en plusieurs étapes successives, les détails varient, mais des procédures sémantiques doivent être attachées aux modules du parsing (sauf si la totalité de l'analyse sémantique est séparée du parsing, dans un compilateur multi-passe, ce qui n'est pas très commode). Il serait fort utile de pouvoir attacher cette sémantique de manière régulière, lisible, et facile à déboguer. Si une bonne partie du générateur de code est attachée au parseur, on parle de <i><b>translation pilotée par la syntaxe</b></i>.
<p>

Quand on discute la sémantique d'un programme, on pose les questions : "quelle est la <i>signification</i> de tel, ou tel objet syntaxique?". Pour une constante numérique explicite, par exemple "2.54" la réponse est claire : c'est un nombre, et sa signification est sa valeur. Pour une chaîne "Belle marquise ..." - la valeur peut être la chaîne elle même, stockée sans aucune conversion.
<p>

Mais ceci peut être une réponse <SPAN class=ib>très incomplète</SPAN>. Nous pouvons avoir besoin de la longueur de la chaîne directement durant la compilation pour pouvoir allouer la mémoire. Pour les nombres ce n'est pas seulement la valeur qui compte, mais p. ex. <EM>le type</EM> de la constante, et le fait qu'il s'agisse d'une <SPAN class=ib>constante</SPAN>. Ceci peut optimiser la compilation, en précalculant les sous-expressions constantes (les expressions composées uniquement des constantes, et des opérateurs d'une classe qui permet cette optimisation ; par exemple un bon compilateur C traduira automatiquement <TT>x=8*(5-2)</TT> en <TT>x=24</TT>).
<p>

Une variable a son adresse, son type (si le langage est statiquement typé) et sa taille, la valeur pendant la compilation normalement n'existe pas, sauf si la déclaration est accompagnée d'une initialisation, <I>et que cette variable est considérée statique</I>. Une expression opérationnelle, une instruction, etc. - en général, les morceaux de code, -  possèdent aussi leurs adresses. Ils peuvent référencer aussi les adresses (étiquettes) du code suivant, celui qui sera exécuté après. Ainsi le compilateur peut stocker les fragments du code dans des listes, et rassembler un vecteur avec le code contigu, plus compacte et rapide, à la fin du processus. Les adresses sont donc aussi des attributs des entités reconnues par le parseur.
<p>

Une instruction conditionnelle peut référencer deux étiquettes (adresses): "<b>codeThen</b>" et "<b>codeElse</b>".
Bref, <SPAN class=ib>tout</SPAN> objet syntaxique possède un certain nombre d'attributs, de propriétés, parfois très variées. Dans notre stratégie de parsing descendant, où chaque non-terminal devient une procédure "monadisée", cette procédure doit s'occuper de la sémantique, de la gestion des attributs, appliquer les constructeurs, filtres, etc.

Nous en avons fait quelques exemples, et ceci n'était pas difficile. Pour les parseurs monolithiques (une procédure qui fait tout) pilotés par des tableaux, les opérations sémantiques doivent être attachées aux données représentant les productions syntaxiques, et ceci est plus complexe (les stratégies orientées-objet peuvent être efficaces dans ce cas, mais le domaine "compilation orientée-objet" reste un terrain encore mal exploité dans la pratique pédagogique).
<p>

Pour les <SPAN class=ib>générateurs de parseurs</SPAN> la situation est encore un peu différente. L'utilisateur ne construit pas le parseur, mais la <A HREF="javascript:alert('Imaginez que le sapin syntaxique est décorée \npar des boules sémantiques')" class="gr"> grammaire "décorée"</A> : les règles syntaxiques, ainsi que quelques opérations sémantiques <SPAN class=ib>sous forme symbolique</SPAN>, par exemple : l'opérateur "+" doit déclencher l'appel à la procédure d'addition, appliquée aux valeurs qui correspondent aux objets reconnus comme arguments de cet opérateur. 
<p>

Il existe toute une théorie de <EM>grammaires attribuées</EM> qui traite les relations entre les attributs, impliquées par la production syntaxique. Nous ne pouvons aborder ce problème sur le plan formel. Rappelons cependant les exercices faits en TD de la semaine de 7.12. La construction (récursive) d'une liste ou chaîne utilise l'itération, p. ex. à droite :
<PRE class="he">
liste ::= EPS | elem liste
</PRE>
Pour ajouter de la sémantique, il faut d'abord séparer les alternatives, et rendre uniques les symboles dans une production, p. ex.:
<PRE class="he">
liste ::= EPS
liste<SUB>0</SUB> ::= elem liste<SUB>1</SUB>
</PRE>
Ensuite il faut décider quels sont les attributs des objets. Ici il en a deux : la liste elle même, sa valeur, ainsi que sa longueur. Finalement, nous attachons à nos production des règles sémantiques suivantes :
<p>
<TABLE border=1  width=100%>
<TR>
<TD class="be" width=45%>liste ::= EPS</td><td class="he">liste.val=[ ]; liste.longueur=0</td></tr>
<TR>
<TD class="be">liste<SUB>0</SUB> ::= elem liste<SUB>1</SUB></td>
  <td class="he">liste<SUB>0</SUB>.val = elem.val : liste<SUB>1</SUB>.val; 
  liste<SUB>0</SUB>.longueur = 1 + liste<SUB>1</SUB>.longueur</td></tr>
</TABLE>
<p>
(Bien sûr, dans cet exemple "1" est la longueur de l'item <b>elem</b>.)
<p>
<H4>Construction des entiers</H4>
<p>
La règle <SPAN class="he">
int ::= char int
</SPAN>
n'est pas très différente de la production qui construit les chaînes ou les listes, mais sa structure sémantique est plus riche, car la construction de la valeur finale est plus compliquée. <SPAN class=ib>Si on utilise directement cette règle</SPAN> (et non pas une autre, p. ex. la règle récursive à gauche), il faut prévoir les attributs suivants :
<UL>
<LI> La valeur numérique d'un caractère ; sa valeur absolue, ainsi que sa "vraie" valeur relative qui dépend de sa position. Donc, aussi : la position de ce caractère.
<LI> Cette position dépend de la longueur de la chaîne suivante, donc il faut prévoir l'attribut correspondant.
<LI> Finalement, la valeur de l'entier.
</UL><p>
On adopte la convention suivante de numérotation des positions : "...6543210". Voici les règles décorées :
<p>
<A NAME="algdec"> </A>
<p>
<TABLE border=1 width=100%>
<TR>
<TD class="be" width=40%>int ::= chiffre intseq</td>
 <td class="he">chiffre.val=chiffre.code&times;10<SUP>chiffre.pos</SUP>; chiffre.pos=intseq.lngth;
   int.val=chiffre.val+intseq.val;</td></tr>
<TR>
<TD class="be">intseq ::= EPS</td>
  <td class="he">intseq.val=0; intseq.lngth=0;</td></tr>
<TR>
<TD class="be" width=40%>intseq<SUB>0</SUB> ::= chiffre intseq<SUB>1</SUB></td>
  <td class="he">chiffre.val=chiffre.code&times;10<SUP>chiffre.pos</SUP>; chiffre.pos=intseq<SUB>1</SUB>.lngth;
   intseq<SUB>0</SUB>.val=chiffre.val+intseq<SUB>1</SUB>.val;
   intseq<SUB>0</SUB>.lngth=1+intseq<SUB>1</SUB>.lngth;</td></tr>
</TABLE>
<p>
<p><HR WIDTH="95%" ALIGN=CENTER>
<P>
L'analyse sémantique d'une autre définition des entiers : <SPAN class="he">
int ::= chiffre | int chiffre
</SPAN>
est un peu différente. Le caractère possède une seule valeur, sa position ne joue aucun rôle, et l'entier à droite peut être évalué plus directement. Voici la grammaire appropriée, et ses décorations sémantiques :
<p>
<TABLE border=1 width=100%>
<TR>
<TD class="be" width=45%>int ::= chiffre</td>
 <td class="he">int.val = chiffre.code</td></tr>
<TR>
<TD class="be">int<SUB>0</SUB> ::= int<SUB>1</SUB> chiffre</td>
  <td class="he">int<SUB>0</SUB>.val = 10&times;int<SUB>1</SUB>.val + chiffre.code</td></tr>
</TABLE>
<p>
Notez que ceci est justement la procédure utilisée précédemment. Nous avons exploité sémantiquement la règle récursive à gauche, même si pour des raisons techniques il fallait normaliser la grammaire selon Greibach. Ces raisons techniques cessent d'exister si on utilise la stratégie ascendante du parsing, car dans ce cas le non-terminal n'est pas une procédure récursive, mais une "chose". Avec nos parseurs monadiques il fallait jouer avec le contexte gauche, ce qui n'était pas difficile, mais pas très évident non plus.
<p>

À présent il faut répondre à la question : comment coder tout cela dans un cas général? 

<H4>Quelques généralités.</H4>
<p>
Pour une production
<PRE class="he">
N ::= X<SUB>1</SUB> X<SUB>2</SUB> X<SUB>3</SUB> ... X<SUB>n</SUB>
</PRE>
<p>
les attributs attachés à <SPAN class="he">N</SPAN>, et construits avec les attributs des <SPAN class="he">X<SUB>i</SUB></SPAN> portent le nom d'<EM>attributs synthétisés</EM>. Par contre, les attributs des entités à droite (y compris l'instance récursive du non-terminal qui est en train d'être défini) s'appellent les <EM>attributs hérités</EM>. Ils peuvent être "hérités" de l'"ancêtre" - le symbole à gauche, ou des "frères". Normalement la gestion des attributs synthétisés est plus facile ; ces attributs constituent ensemble la <SPAN class=ib>valeur retournée par le parseur</SPAN>, et ceci est bien adapté aux parseurs procéduraux récursifs - la valeur est obtenue lors du <I>retour</I> des appels récursifs qui - symboliquement - descendent les branches de l'arbre syntaxique. On a pas besoin du style monadique, bien sûr, mais dans ce style la construction aurait symboliquement la forme suivante :
<PRE>
nonterm = x1 &gt;&gt;=\(CX1 a11 a12 ...) -&gt x2 &gt;&gt;=
   \(CX2 a21 a22 ...) -&gt ...
   ... -&gt return (construc a11 ... a21 ...)
</PRE><p>
c'est-à-dire : on récupère les attributs des non-terminaux X, et on les manipule directement dans la procédure parseur. Évidemment, ce traitement peut procéder par étapes intercalées entre chaque fragment du parsing.
<p>

Mais comment gérer les attributs hérités? Il en existe deux types : l'héritage "vertical" (de l'ancêtre), et l'héritage "horizontal" (des frères). 
<p>

Voici un exemple où les attributs hérités peuvent être utiles. Si nous voulons construire une "boîte" - une structure de données qui représente l'affichage bi-dimensionnelle d'une expression algébrique (voir votre <A HREF="devoir.html">devoir</A>), il est évident que la largeur de la barre de fraction est héritée soit de celle du dénominateur, ou du numérateur (on retient la largeur maximale). De même, la position de l'exposant dépend de la hauteur de la base. Donc, l'héritage horizontal est visible immédiatemment, et on le peut implanter par la stratégie descendante sans difficultés. 
<p>

Supposons qu'au lieu de stocker dans chaque boîte sa position relative à la boîte-mère, on sauvegarde directement la position absolue sur la page (peut-être pour accélérer l'affichage). Nous aurons besoin alors de l'héritage vertical, car évidemment la position d'une sous-expression est déterminée d'abord par la position de sa boîte englobante. L'implantation peut être très variée, selon le style de programmation. Ici, <em>dans notre stratégie récursive descendante il suffit de <em>paramétrer</em> le parseur</em> (le non-terminal) :
<PRE>
nonterm atr = ... &gt;&gt;= \a... -&gt; ... x1 (f atr a) &gt;&gt;=  ...
</PRE>
<p>

Ainsi <TT>nonterm</TT> peut passer ses attributs  (son paramètre) à <TT>x1</TT>. Mais un parseur ascendant commence par les feuilles de l'arbre syntaxique, et gère la sémantique en réduisant les feuilles, puis les branches en branches plus proches de la racine. Dans ce cas la gestion de l'héritage est plus délicate. Cette gestion est un peu compliquée, et les générateurs de parseurs souvent demandent un pré-traitement de la grammaire pour supprimer les attributs hérités. Thomas Johnsson (Chalmers University, Suède), un des auteurs du langage LML (Lazy ML, un des premiers langages fonctionnels paresseux, précurseur de Haskell) a démontré que cette manipulation devient très simple et élégante si on utilise la programmation paresseuse, où les objets ("données" et non pas - fonctions) peuvent s'auto-référencer, ou avoir des références récursives croisées, sans faire "exploser" la mémoire. Malheureusement nous ne pouvons discuter ici cette technique, mais nous verrons un exemple où le codage paresseux facilite énormément le codage des boucles, qui peuvent générer les attributs auto-référentiels.
<p>

Voici la reconstruction des entiers par la règle récursive à droite avec des attributs. Ceci n'est pas une solution recommendable dans la pratique. (On utilise les mêmes noms que dans la <A HREF="#algdec">grammaire décorée ci-dessus</A>.)
<PRE class="rd">
int = chiffre &gt;&gt;= \c -&gt; intseq &gt;&gt;= \(lngth,val) -&gt;
      return (val + (code c)*10^lngth)

intseq = chiffre &gt;&gt;= \c -&gt; intseq &gt;&gt;= \(lngth,val) -&gt;
         let char_val=(code c)*10^lngth
         in return(lngth+1,char_val+val)
  # return (0,0)
</PRE>
<p>

Et voici, encore une fois la grammaire et la translation des règles de construction des entiers après la normalisation de Greibach. Notez le fait que la syntaxe est <i><b>exactement</b></i> la même que pour la règle récursive à droite <i>ab ovo</i>, mais <b>char.val</b> est indépendant du contexte, équivalent au code numérique (réduit) du caractère, et <b>intseq</b> possède un autre attribut : <b>cx</b>, qui est hérité.

<p>
<TABLE border=1 width=100%>
<TR>
<TD class="be" width=40%>int ::= chiffre intseq</td>
 <td class="he">int.val=intseq.val; intseq.cx=chiffre.val;</td></tr>
<TR>
<TD class="be">intseq ::= EPS</td>
  <td class="he">intseq.val=intseq.cx;</td></tr>
<TR>
<TD class="be" width=40%>intseq<SUB>0</SUB> ::= chiffre intseq<SUB>1</SUB></td>
  <td class="he">intseq<sub>1</sub>.cx=10&times;intseq<sub>0</sub>.cx+chiffre.val; intseq<sub>0</sub>.val=intseq<sub>1</sub>.val</td></tr>
</TABLE>
<p>

ce qui correspond à
<pre>
int = chiffre &gt;&gt;= \c -&gt; intseq (code c)
intseq cx = chiffre &gt;&gt;= \c -&gt; intseq (10*cx+code c) 
          # return cx
</pre>
<p>

<em>Attention ! <img src="../icons/strobe.gif"align=absmiddle> Dans cette section les examples de parseurs écrits en style monadique sont considérés - pour la simplicité - comme "presque" déterministes, c'est-à-dire, le résultat est un seul objet et non pas une liste. Mais le parseur peut échouer.
</em>

Donc, si nous voulions implanter sérieusement les parseurs présenter ici, il faudrait utiliser de façon cohérente le type <tt>Maybe</tt>, définir le <i><b>bind</b></i> correspondant, etc. Nous ne le faisons pas uniquement pour ne pas surcharger le cours avec les détails qui ne sont pas essentiels (ici), mais le lecteur doit être vigilant ! Construction de tels parseurs constitue un beau sujet d'examen.
<p>

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif">
</CENTER>
<p>

<H3>Analyse des attributs et génération du code</H3>
<p>

Si le programme est composé d'instructions séparées par le point-virgule, et si notre machine virtuelle (le modèle d'exécution) n'est pas très éloignée de la machine à pile style PostScript discutée précédemment, la sérialisation des instructions est <a href="javascript:alert('Vous verrez que ceci est un mensonge...')" class="gr">presque triviale</a> et automatique : la liste des instructions dans le programme source devient une liste des instructions compilées, et si chaque instruction est déjà une liste contenant les opérations élémentaires, il suffit de concaténer le tout. Ou, ce qui est encore plus facile, considérer que ";" dans le programme source correspond à l'opérateur "++"  qui forme le code. Le seul travail un peu plus élaboré est nécessaire pour pouvoir traiter les branchements, donc les conditionnelles et les boucles. Il faut également penser à gérer les intricacies des appels fonctionnels, le stockage des arguments, les retours, etc. Comment la gestion des attributs peut être utilse ici?
<p>


Revenons d'abord à la compilation des expressions algébriques. Voici une proposition relativement simpliste, sans <a href="javascript: alert('Précompilation des constantes, \nreconnaissance des sous-expressions identiques, \nusage des registres, etc.')" class="gr">aucune optimisation</a>, sans gestion des types, et avec l'adressage des variables <b>très</b> simplifié (lire : caché sous la moquette...). Il n'y a rien de nouveau ici, la seule différence est le remplacement de l'attribut "val" par "code", puisque pendant le parsing des nombres le parseur se comporte comme un interprète qui construit explicitement les valeurs numériques, mais pour des expressions quelconques, évidemment les valeurs n'existent pas, on génère le code.
<p>


<a name="gramex"> </a>
<p>
<TABLE border=2 width=100% bgcolor="#FFF0D0" bordercolor="#0000F0">
<TR>
<TD width=55% class="be">expr ::= terme termlist</td>
 <td class="he">expr.code=termlist.code; termlist.cx=terme.code;</td></tr>
<TR>
<TD width=55% class="be">termlist<sub>0</sub> ::= addOp terme termlist<sub>1</sub></td>
  <td class="he">termlist<sub>0</sub>.code=termlist<sub>1</sub>.code; termlist<sub>1</sub>.cx=termlist<sub>0</sub>.cx ++ terme.code ++ opAdd.op;</td></tr>
<TR>
<TD width=55% class="be">termlist ::= EPS</td>
  <td class="he">termlist.code=termlist.cx;</td></tr>
</TABLE>
<p>

etc. Le lecteur peut aisément compléter ces règles, et coder tout par l'enchaînement monadique - <a href="#genatt">voir TD</a>. 
<p>

La construction d'un bloc d'instructions est  - apparemment - identique à la création d'une liste ou une chaîne, comme il a déjà été mentionné : 
<p>
<TABLE border=2 width=100% bgcolor="#FFF0D0" bordercolor="#0000F0">
<TR>
<TD width=35% class="be">bloc<sub>0</sub> ::= instr ";" bloc<sub>1</sub></td>
 <td class="he">bloc<sub>1</sub>.suiv=bloc<sub>0</sub>.suiv; instr.suiv=bloc<sub>1</sub>.code; bloc<sub>0</sub>.code=instr.code;</td></tr>
<TR>
<TD width=35% class="be">bloc ::= EPS</td>
  <td class="he">bloc.code=bloc.suiv;</td></tr>
</TABLE>
<p>
Cependant, on peut coder cela différemment :
<pre>
bloc = instr &gt;&gt;=\code -&gt; lit ";" &gt;&gt; bloc &gt;&gt;= 
       \cod1 -&gt; (code ++ cod1)
</pre><p>
On ne garde pas l'adresse suivante (la continuation) comme un attribut à part entière.
Ceci est dû au fait que l'enchaîment "statique" (ou "physique", la concaténation), c'est-à-dire le placement d'une instruction derrière une autre, implique automatiquement l'enchaînement "dynamique" : le transfert de contrôle. Mais nous pouvons avoir également le transfert explicit différent de l'enchaînement statique, ceci devient inévitable lors du parsing des structures de contrôle. Par exemple, le parsing de
<pre>
if <i>cond</i> then <i>codeThen</i> else <i>codElse</i>
</pre>
<p>
doit prévoir <i><b>deux</b></i> "fils de contrôle" après le test de la condition. Dans notre modèle style PostScript les codes "then" ou "else" étaient des procédures (thunks) empilées et exécutées par la primitive <tt>if</tt> ou <tt>ifElse</tt>. Toutefois, le code actuel sera <i><b>de plus bas niveau</b></i>, et aura la forme plus propice au codage plus linéaire et local, correspondant au diagramme suivant :
<p>
<center><img src="ifdiag.gif">
</center>
<p>

où les lignes noires dénotent la liaison statique et le transfert de contrôle par défaut, et les lignes rouges - le transfer explicit. Les primitives <tt>goto</tt> et <tt>ifFalse</tt> sont paramétrées par le <i><b>code</b></i>, mais ce code fait partie du bloc, il s'agit d'une adresse à l'intérieur de la liste d'instructions. Naturellement si on place le code dans un tableau et non pas dans une liste, il faudra faire une modification, par exemple remplacer cette adresse par l'indice du tableau, mais c'est une modification mineure. 
<p>

Pour les deux instructions de branchement il faudra prévoir un attribut spécial - l'adresse-cible. Voici le jeu d'attributs, relativement simple, mais avec une mauvaise surprise :
<p>

<p>
<TABLE border=2 width=100% bgcolor="#FFF0D0" bordercolor="#0000F0">
<TR>
<TD class="be" width=40%>cnd ::= <u>if</u> cond <u>then</u> codeThen <u>else</u> codeElse</td>
 <td class="he">cnd.code=cond.code ++ (ifFalse(codeElse.code) : codeThen.code ++
   goto(cnd.suiv) : codeElse.code; </td></tr>
</TABLE>
<p>

L'instruction <b>goto</b> a besoin d'un attribut hérité, la suite de l'instruction entière, sinon, on ne peut pas compiler le branchement. Cet attribut sera son paramètre, p. ex. <b>goto(cnd.suiv)</b>. En fait, une machine de bas niveau paramétrise le branchement de cette façon, et dans notre machine virtuelle nous pouvons faire le même. Mais nous pouvons également laisser la primitive <b>goto</b> sans paramètre explicit, et qui récupère sa cible depuis la pile des données : <tt>[ld (cnd.cible), goto]</tt>. La seule instruction parametrée sera le "load", toutes les autres primitives trouvent leurs données sur la pile. On peut faire le même avec <b>ifFalse</b> etc.
<p>

Ceci dit, nous sommes un peu coincés ... <em>On ne peux pas simultanément</em> 
<ul>
<li> respecter la règle sémantique, par exemple <b>instr.suiv = bloc<sub>1</sub>.code</b> dans :<b>bloc<sub>0</sub> ::= instr ";" bloc<sub>1</sub></b>, et

<li> compiler le code par la concaténation : <b>instr.code ++ bloc<sub>1</sub>.code</b>,
</ul><p>
car la concaténation recopie son premier argument, et <b>instr.suiv</b> n'est plus d'aucune utilité. L'objet <b>instr</b> devient une simple liste, et non pas un objet avec un "crochet" <b>.suiv</b> à la fin. Mais la compilation ainsi devient moins rapide - il faudra éventuellement recopier beaucoup de code. De plus, si on laisse le parseur des instructions "normales" sans paramètres, mais si on paramétrise les conditionnelles, les branchements, etc., le code devient  hétérogène, ce qui est toujours mauvais, pour la clarté et pour l'architecture du compilateur. Pour l'instant, pour la simplicité on laisse le modèle de compilation comme ça, mais le sujet dera repris prochaînement.
<p>

On peut poser la question concernant le parsing du bloc <i><b>avec</b></i> le paramètre (l'attribut hérité) du - par exemple - <b>bloc</b>. Comment il est obtenu, comment le parseur peut opérer avec? Cette question a été effectivement posée par un de vous. Rappelons donc que la stratégie du parsing exploitée ici est descendante. On commence le parsing par l'application du parseur-racine, p. ex. <b>program</b> ou flot de données. Si l'attribut <b>.suiv</b> est utilisé de manière cohérente, il faut mettre ici la continuation du programme entier, par exemple le code <b>[stop]</b>, ou un autre mécanisme de retourner le contrôle au "père" du programme lancé. Ensuite les continuations se propagent vers les feuilles. Mais l'exemple ci-dessus montre une difficulté d'application de cette règle de façon cohérente, à travers tous les parseurs-générateurs du code.
<p>

<i><b>Ce sujet n'est pas terminé !</b></i>


<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif">
</CENTER>
<p>


<H3>Stratégie ascendente LR</H3>
<p>

La présentation ci-dessous est très succinte et incomplète. La construction manuelle d'un parseur ascendant LR1 (<I>left-to-right</I>; 1 item-<I>lookahead</I>) est pénible, mais la technique est universelle et relativement efficace, donc quelques générateurs de parseurs (notamment le notoire Yacc) sont basés sur ces principes, et il est judicieux de leur consacrer un peu de temps.
<p>

La "machine du parsing" est un automate à pile identique pour tous les langages. Quand on construit un parseur à l'aide de Yacc, on spécifie seulement la grammaire (décorée par les règles sémantiques, et complétée par quelques procédures spécifiques, codées directement en "C" par l'utilisateur). Le générateur fournit le parseur sous forme d'une procédure (normalement en "C") qui emballe cet automate, et y attache les tableaux de pilotage qui contiennent la totalité d'information syntaxique concrète. Les règles sémantiques sont transformées en code "C"). Le parseur opère sur une pile où il place des suites de forme <TT>s<SUB>0</SUB> X<SUB>0</SUB> s<SUB>1</SUB> X<SUB>1</SUB> s<SUB>2</SUB> ... X<SUB>m</SUB> s<SUB>m</SUB></TT>, où chaque <TT>s<SUB>k</SUB></TT> représente l'état de l'automate (l'indice d'un noeud de son graphe ; c'est une étiquette formelle sans autre signification
), et <TT>X<SUB>k</SUB></TT> est un symbole syntaxique, terminal ou non-terminal (après la réduction). Le stockage des symboles <TT>X</TT> sur la pile n'est pas indispensable dans une implantation concrète d'un parseur, mais ceci facilite sa présentation.
<p>

Le parseur utilise deux tableaux : ACTION et GOTO. Le deuxième tableau représente la fonction des transitions de l'automate. GOTO[s,X] prend un état et un symbole de la grammaire (non-terminal) comme indices, et retourne un nouvel état.
<P>

Le tableau ACTION[s,a] est un peu plus compliqué. Il est indexé par les états et les lexèmes sur le flot d'entrée. Le contenu de ce tableau appartient à une des catégories suivantes :
<OL>
<LI> <B>shift s</B>, où s est un état,
<LI> <B>reduce p</B> par une production, disons <TT>p ::: A -&gt; alpha</TT>,
<LI> <B>accept</B> qui termine le parsing, et
<LI> <B>error</B>, qui arrête le parsing.
</OL>
<p>

On commence par placer l'état initial de l'automate sur la pile. Dans le cas général, le parseur est décrit par la configuration : pile - flot d'entrée (restant), sous la forme
<PRE class="hev">
(s<SUB>0</SUB> X<SUB>1</SUB> s<SUB>1</SUB> X<SUB>2</SUB> s<SUB>2</SUB> ... X<SUB>m</SUB> s<SUB>m</SUB> ;  a<SUB>i</SUB> a<SUB>i+1</SUB> a<SUB>i+2</SUB> ... a<SUB>n</SUB> $)
</PRE><p>
où <B>a<SUB>i</SUB></B> est le lexème courant. Le parseur vérifie l'état <B>s<SUB>m</SUB></B> sur le sommet de la pile, et consulte le tableau ACTION[s<SUB>m</SUB>,a<SUB>i</SUB>]. La configuration résultante dépend de la valeur de cet élément :
<OL>
<LI> Si ACTION[s<SUB>m</SUB>,a<SUB>i</SUB>] = shift s, on passe au lexème suivant avec la configuration
<PRE class="hev">
(s<SUB>0</SUB> X<SUB>1</SUB> s<SUB>1</SUB> X<SUB>2</SUB> s<SUB>2</SUB> ... X<SUB>m</SUB> s<SUB>m</SUB> a<SUB>i</SUB> s ;  a<SUB>i+1</SUB> a<SUB>i+2</SUB> ... a<SUB>n</SUB> $)
</PRE>

<LI> Si ACTION[s<SUB>m</SUB>,a<SUB>i</SUB>] = reduce (A -&gt; alpha), alors le parseur récupère la longueur <TT>r</TT> de la chaîne <TT>alpha</TT>, et dépile <TT>2r</TT> objets (symboles et états), laissant sur le sommet l'état s<SUB>m-r</SUB>. Ensuite
le tableau GOTO est consulté, et un nouvel état s=GOTO[s<SUB>m-r</SUB>,A] sera empilé, avec le résultat de la réduction : A. La nouvelle configuration est
<PRE class="hev">
(s<SUB>0</SUB> X<SUB>1</SUB> s<SUB>1</SUB> X<SUB>2</SUB> s<SUB>2</SUB> ... X<SUB>m-r</SUB> s<SUB>m-r</SUB> A s ;  a<SUB>i</SUB> a<SUB>i+1</SUB> ... a<SUB>n</SUB> $)
</PRE><p>
et le flot d'entrée reste intacte. La procédure sémantique correspondante est exécutée.

<LI> Si ACTION[s<SUB>m</SUB>,a<SUB>i</SUB>] = accept, l'analyse est terminée.
<LI> Sinon, le texte parsé est erroné, et il faut gérer ce cas afin de permettre de continuer le parsing. Ceci peut être assez délicat. Souvent le parseur rejète tous les lexèmes suivants, et essaie de trouver un terminateur d'instruction, ce qui provoque la génération de plusieurs erreurs secondaires. On peut, bien sûr, toujours "paniquer", et arrêter le parsing immédiatemment, comme fait Hugs.
</OL>
<p>

Pour la bien connue grammaire algébrique :
<OL class="he">
<LI> E ::= E + T
<LI> E ::= T
<LI> T ::= T*F
<LI> T ::= F
<LI> F ::= (E)
<LI> F ::= id
</OL><p>
le tableau de pilotage contient  (les items manquants sont considérés erronés):
<p>
<TABLE  width="65%" border="1" cellspacing="0" bgcolor="#80ffff" bordercolor="#ff0000" align="center">
<TR bgcolor="#C0FFB0">	<TD align="center">État</TD><TD align="center">Action</TD><TD align="center">Goto</TD>
</TR>
<tr>
<td>&nbsp;</td>
<td rowspan=13>
<TABLE cellpadding=1>
<TR align="center" bgcolor="#FFC0A0">
<TD>&nbsp; id &nbsp;</TD><TD>&nbsp; + &nbsp;</TD><TD>&nbsp; * &nbsp;</TD><TD>&nbsp; ( &nbsp;</TD><TD>&nbsp; ) &nbsp;</TD><TD>&nbsp; $ &nbsp;</TD></TR>
<TR>
<TD>s5</TD><TD>&nbsp;</TD><TD>&nbsp;</TD> <TD>s4</TD><TD>&nbsp;</TD><TD>&nbsp;</TD>
</TR>
<TR>
<TD>&nbsp;</TD><TD>s6</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>acc</TD>
</TR><TR>
<TD>&nbsp;</TD><TD>r2</TD><TD>s7</TD><TD>&nbsp;</TD><TD>r2</TD><TD>r2</TD>
</TR><TR>
<TD>&nbsp;</TD><TD>r4</TD><TD>r4</TD><TD>&nbsp;</TD><TD>r4</TD><TD>r4</TD>
</TR>
<TR>
<TD>s5</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>s4</TD><TD>&nbsp;</TD><TD>&nbsp;</TD>
</TR><TR>
<TD>&nbsp;</TD><TD>r6</TD><TD>r6</TD><TD>&nbsp;</TD><TD>r6</TD><TD>r6</TD>

</TR>
<TR>
<TD>s5</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>s4</TD><TD>&nbsp;</TD><TD>&nbsp;</TD>
</TR><TR>
<TD>s5</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>s4</TD><TD>&nbsp;</TD><TD>&nbsp;</TD>
</TR><TR>
<TD>&nbsp;</TD><TD>s6</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>s11</TD><TD>&nbsp;</TD>
</TR><TR>
<TD>&nbsp;</TD><TD>r1</TD><TD>s7</TD><TD>&nbsp;</TD><TD>r1</TD><TD>r1</TD>
</TR><TR>
<TD>&nbsp;</TD><TD>r3</TD><TD>r3</TD><TD>&nbsp;</TD><TD>r3</TD><TD>r3</TD>
</TR><TR>
<TD>&nbsp;</TD><TD>r5</TD><TD>r5</TD><TD>&nbsp;</TD><TD>r5</TD><TD>r5</TD>
</TR>
</TABLE>
</td>
<td rowspan=13>
<TABLE cellpadding=1>
<TR align="center"  bgcolor="#FFC0A0">	
<TD>&nbsp; E &nbsp;</TD><TD>&nbsp; T &nbsp;</TD><TD>&nbsp; F &nbsp;</TD>
</TR>
<TR>
<TD>&nbsp; 1 &nbsp;</TD><TD>&nbsp; 2 &nbsp;</TD><TD>&nbsp; 3 &nbsp;</TD>
</TR>
<tr><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></tr>
<tr><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></tr>
<tr><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></tr>
<TR>
<TD>&nbsp; 8 &nbsp;</TD><TD>&nbsp; 2 &nbsp;</TD><TD>&nbsp; 3 &nbsp;</TD>
</TR>
<tr><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></tr>
<TR>
<TD>&nbsp;</TD><TD>&nbsp; 9 &nbsp;</TD><TD>&nbsp; 3 &nbsp;</TD>
</TR>
<TR>
<TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp; 10 &nbsp;</TD>
</TR>
<tr><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></tr>
<tr><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></tr>
<tr><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></tr>
<tr><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD></tr>
</TABLE>
</td>
</tr>
<tr><td>0</td></tr>  <tr><td>1</td></tr>  <tr><td>2</td></tr>  <tr><td>3</td></tr>
<tr><td>4</td></tr>  <tr><td>5</td></tr>  <tr><td>6</td></tr>  <tr><td>7</td></tr>
<tr><td>8</td></tr>  <tr><td>9</td></tr>  <tr><td>10</td></tr>  <tr><td>11</td></tr>
</TABLE>
<p>
où <b>s<sub>k</sub></b> signifie le shift de l'état <b>k</b>, et <b>r<sub>k</sub></b> - réduire la production <b>k</b>. Le tableau ci-desssus a été construit par les êtres humains (Aho, Sethi et Ullman). La construction de ces tableaux à partir de la grammaire est la partie la plus pénible du travail, mais il faut savoir aussi que leur génération automatique résulte normalement en quelque chose de beaucoup plus grand ; pour bien optimiser un automate il faut avoir un peu d'intelligence. Il existe plusieurs techniques de construction et d'optimisation des automates LR. La plus simple, SLR (simple LR) produit évidemment les tableaux les moins efficaces, et le nombre de grammaires accepté par cette méthode est restreint. La technique la plus générale s'appelle "canonique", mais elle n'est presque jamais utilisée. Dans la pratique on utilise la technique LALR (Look-ahead LR) qui génère des tableaux relativement petits, et dont les restrictions par raport à la technique canonique ne sont pas gênantes. Nous n'allons pas décrire la construction des automates LR, cette partie de la théorie est intéressante pour les constructeurs des générateurs de parseurs.
<p>

Voici les étapes du parsing de l'expression (symbolique) <B>id*id+id</B> à l'aide de nos tableaux. L'état initial c'est l'état 0 :
<TABLE width="80%" border="1" cellspacing="0" bgcolor="#80ffff" bordercolor="#ff0000" align="center">
<TR bgcolor="#FFD080">	
<td>&nbsp;</td><TD align="center">Pile</TD><TD align="center">Flot</TD><TD align="center">Action</TD>
</TR><tr>
<td>(1)</td> <td>0 </td> <td align="right">id * id + id $ </td> <td>shift </td>
</tr><tr>
<td>(2)</td> <td>0 id 5</td> <td align="right">* id + id $ </td> <td>reduce: F -&gt; id </td>
</tr><tr>
<td>(3)</td> <td>0 F 3</td> <td align="right">* id + id $ </td> <td>reduce T -&gt; F </td>
</tr><tr>
<td>(4)</td> <td>0 T 2</td> <td align="right">* id + id $ </td> <td>shift </td>
</tr><tr>
<td>(5)</td> <td>0 T 2 * 7</td> <td align="right">id + id $ </td> <td>shift </td>
</tr><tr>
<td>(6)</td> <td>0 T 2 * 7 id 5</td> <td align="right">+ id $ </td> <td>reduce: F -&gt; id </td>
</tr><tr>
<td>(7)</td> <td>0 T 2 * 7 F 10</td> <td align="right">+ id $ </td> <td>reduce: T -&gt; T*F </td>
</tr><tr>
<td>(8)</td> <td>0 T 2</td> <td align="right">+ id $ </td> <td>reduce: E -&gt; T </td>
</tr><tr>
<td>(9)</td> <td>0 E 1</td> <td align="right">+ id $ </td> <td>shift </td>
</tr><tr>
<td>(10)</td> <td>0 E 1 + 6</td> <td align="right">id $ </td> <td>shift </td>
</tr><tr>
<td>(11)</td> <td>0 E 1 + 6 id 5</td> <td align="right">$ </td> <td>reduce: F -&gt; id </td>
</tr><tr>
<td>(12)</td> <td>0 E 1 + 6 F 3</td> <td align="right">$ </td> <td>reduce: T -&gt; F </td>
</tr><tr>
<td>(13)</td> <td>0 E 1 + 6 T 9</td> <td align="right">$ </td> <td>reduce: E -&gt; E+T </td>
</tr><tr>
<td>(13)</td> <td>0 E 1</td> <td align="right">$ </td> <td>accept </td>
</tr>
</TABLE>
<p>
Essayez de suivre les étapes du parsing de l'expression <B>id+id*id</B>. Lisez la documentation du Bison, éventuellement  la documentation fournie avec le paquetage Gentle - un des plus faciles systèmes d'aide à la compilation, qui ressemble beaucoup à Prolog (conceptuellement et syntaxiquement, mais le code généré utilise Yacc/Bison, et il est donc basé sur la stratégie LR1).
<p>



<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/rainbow.gif" WIDTH="90%" HEIGHT="12">
</CENTER>
<p>

<p>
<H2> &nbsp; TD &nbsp; </H2>
<p>

<a name="genatt"> </a>
<h3>Génération attribuée du code pour les expressions algébriques.</h3>
<p>

La <a href="#gramex">grammaire attribuée simplifiée</a>, qui définit les expressions et les termes peut être implantée de manière suivante :
<pre>
expr = terme &gt;&gt;=\cod -&gt; termlist cod
termlist cx = addOp &gt;&gt;=\op -&gt; terme &gt;&gt;=\code -&gt;
              termlist (cx ++ code ++ [op]) # return cx
</pre>
<p>
Rappelons que ces parseurs doivent être considérés semi-déterministes ; 0 ou une valeur retournée.
<p>

AddOp doit retourner la commande primitive de la machine-cible. Il faut naturellement prendre tout ceci <i>cum grano salis</i>, pour rendre ce parseur exécutable et adapté à notre machine à pile il faut homogénéiser les résultats, ajouter peut-être quelques balises en accord avec notre définition du "code", etc., mais ceci n'est pas très important ici.

<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH=95% HEIGHT="12" ALT="">
</CENTER>
<p>



<h3>Boucles</h3>
<p>

Voici la boucle : <tt>while <i>expr</i> do <i>instr</i></tt> :
<p>

<center><img src="bwhile.gif" width="518" height="137" alt="">
</center><p>

L'assignation des attributs est évidente, il suffit de regarder le dessin. Le parseur (un peu symboliquement) peut être défini comme ci dessous. On voit qu'à cause de la présence d'une adresse-cible extérieure attachée à un objet interne (le reste pointé par <b>ifFalse</b>), il faudra utiliser un attribut hérité.

<pre>
while suiv = lit "while" &gt;&gt; expr &gt;&gt;= \codc -&gt; lit "do" &gt;&gt;
             instr &gt;&gt;= \codi -&gt;
             let res = codc ++ (ld suiv : [ifFalse]) ++ 
                       codi ++ (ld res : [goto]) ++ suiv
             in return res
</pre>
<p>

Notez l'autoréférence de la liste <tt>res</tt>. Les références croisées dans un code avec les branchements sont parfois difficiles à coder, et les techniques impératives sont un peu tordues (surtout s'il y a des références vers l'avant, pointant sur les étiquettes qui n'ont pas été encore définies. Dans ce cas on génère une instruction de branchement "bidon", et on sauvegarde l'endroit où ce code a été placé. Quand l'étiquette est trouvée, on l'insère dans le code "bidon"). Avec la programmation paresseuse la vie est beaucoup plus douce !
<p>

Voici le codage de la boucle <tt>do <i>instr</i> while <i>expr</i></tt>. Cette fois, pour varier, vous avez proposé l'usage du branchement conditionnel <b>ifTrue</b> au lieu de <b>ifFalse</b>. Ainsi on peut économiser un <b>goto</b>.
<p>

<center><img src="dowhil.gif" width="496" height="51" alt="">
</center><p>

<pre>
dowhile suiv = lit "do" &gt;&gt; instr &gt;&gt= \codi -&gt; lit "while" &gt;&gt;
      expr &gt;&gt;= \codc -&gt; 
      let res = codi ++ codc ++ (ld res : [ifTrue]) ++ suiv 
      in return res
</pre>

<p>

<hr width="95%" align=center size=10>
<p>

Essayons d'assembler une liste-code avec plusieurs branchements, donc un graphe plutôt compliqué, par exemple
<p>
<center><img src="genbra.gif" width="513" height="123" alt=""></center>
<p>

Adoptons la convention que la notation <b>noeud(adr)</b> designe le code dont l'attribut "transfert dynamique" pointe sur l'<b>adr</b>. Pour que le protocole paresseux fasse tout le travail pour nous il suffit d'<i><b>identifier toutes les cibles</b></i>. Nous aurons donc finalement l'assemblage du code suivant :
<pre class="he">
res = noeudA ++ resB
resB = noeudB(resD) ++ noeudC(reste) ++ resD
resD = noeudD ++ noeudE(resB) ++ noeudF(res) ++ reste
</pre>
<p>

Une deuxième passe sur cette liste peut la placer dans un vecteur compact, plus rapide à parcourir qu'une liste chaînée, mais cette opération est complètement triviale, dès que l'assemblage est faite. Pour les techniques traditionnelles de compilation qui opéraient directement avec les vecteurs, et dont la sémantique était stricte, la construction d'un tel amas est une torture. Et ici? Oui, - ceci est devenu un simple sujet d'examen...



<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH=95% HEIGHT="12" ALT="">
</CENTER>
<p>


<h3>Parsing LR de : id+id*id</h3>
<p>

<TABLE width="80%" border="1" cellspacing="0" bgcolor="#80ffff" bordercolor="#ff0000" align="center">
<TR bgcolor="#FFD080">	
<td>&nbsp;</td><TD align="center">Pile</TD><TD align="center">Flot</TD><TD align="center">Action</TD>
</TR><tr>
<td>(1)</td> <td>0 </td> <td align="right">id + id * id $ </td> <td>shift 5</td>
</tr><tr>
<td>(2)</td> <td>0 id 5</td> <td align="right">+ id * id $ </td> <td>reduce id -&gt; F</td>
</tr><tr>
<td>(3)</td> <td>0 F 3</td> <td align="right">+ id * id $ </td> <td>reduce F -&gt; T</td>
</tr><tr>
<td>(4)</td> <td>0 T 2</td> <td align="right">+ id * id $ </td> <td>reduce T -&gt; E</td>
</tr><tr>
<td>(5)</td> <td>0 E 1</td> <td align="right">+ id * id $ </td> <td>shift 6</td>
</tr><tr>
<td>(6)</td> <td>0 E 1 + 6</td> <td align="right">id * id $ </td> <td>shift 5</td>
</tr><tr>
<td>(7)</td> <td>0 E 1 + 6 id 5</td> <td align="right">* id $ </td> <td>reduce id &gt; F</td>
</tr><tr>
<td>(8)</td> <td>0 E 1 + 6 F 3</td> <td align="right">* id $ </td> <td>reduce F -&gt; T</td>
</tr><tr>
<td>(9)</td> <td>0 E 1 + 6 T 9</td> <td align="right">* id $ </td> <td>shift 7</td>
</tr><tr>
<td>(10)</td> <td>0 E 1 + 6 T 9 * 7</td> <td align="right">id $ </td> <td>shift 5</td>
</tr><tr>
<td>(11)</td> <td>0 E 1 + 6 T 9 * 7 id 5</td> <td align="right">$ </td> <td>reduce id -&gt; F</td>
</tr><tr>
<td>(12)</td> <td>0 E 1 + 6 T 9 * 7 F 10</td> <td align="right">$ </td> <td>reduce T*F -&gt; T</td>
</tr><tr>
<td>(13)</td> <td>0 E 1 + 6 T 9</td> <td align="right">$ </td> <td>reduce E+T -&gt; E</td>
</tr><tr>
<td>(13)</td> <td>0 E 1</td> <td align="right">$ </td> <td>accept </td>
</tr>
</TABLE>
<p>



<!-- ********************************************************* --><p>
<CENTER><IMG SRC="../icons/limarro.gif" WIDTH="576" HEIGHT="9" ALT="">
</CENTER>
<p>




<TABLE width=100%>
 <TR><TD align=left><A HREF="comres10.html"><IMG SRC="../icons/gb_larr.gif" border=0 align=absmiddle></A></TD>
<TD align=right><A HREF="comres12.html"><IMG SRC="../icons/gb_rarr.gif" border=0 align=absmiddle></A></TD>
</TR>
</TABLE>
<p>


</FONT>
</BODY>

</HTML>
